﻿package com.manpower.document{

	import com.greensock.TimelineLite;
	import com.greensock.TweenLite;
	import com.greensock.easing.*;
	import com.greensock.plugins.*;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.Shape;
	import flash.display.DisplayObject;
	import com.bobby.time.Delay;
	import com.manpower.util.ClickArea;
	import flash.geom.Rectangle;

	public class MainShell_728x90 extends MovieClip {

		public var clickArea    	: ClickArea;
		public var border			: Shape;
		public var stageWidth		: Number;
		public var stageHeight		: Number;
		
		public var initialX			: Array = new Array;
		public var initialY			: Array = new Array;
		//--------------------------------------------------------------------------
		//  constructor
		//--------------------------------------------------------------------------

		public function MainShell_728x90() {
			this.scrollRect = new Rectangle(0, 0, 728, 90);
			init();
		}

		//--------------------------------------------------------------------------
		//  init
		//--------------------------------------------------------------------------

		private function init():void {
			TweenPlugin.activate([TintPlugin]);

			clickArea = new ClickArea( loaderInfo, stage, 728, 90 );
			clickArea.mouseChildren = false;
			addChild( clickArea );
			
			stageWidth = stage.stageWidth;
			stageHeight = stage.stageHeight;
			
			border = new Shape();
			border.graphics.lineStyle(2,0x546f85);
			border.graphics.drawRect(0, 0, 728, 90);
			addChild(border);

			faces_mc.alpha = copy.alpha = logo_mc.alpha = 0;
			TweenLite.delayedCall( .5, animate );
		}
		
		private function animate():void {
			faces_mc.alpha = 1;
			faces_mc.gotoAndPlay("animate");
			
			var timeline:TimelineLite = new TimelineLite();
			timeline.append( TweenLite.from(faces_mc, 4.5, { x:-370 , y:-400 , scaleX: 6, scaleY:6, delay:.7, ease:Linear.easeOut}) );
			timeline.append( TweenLite.to(logo_mc, .5, { alpha: 1, delay:1, ease:Quad.easeOut  }) );

			timeline.append( TweenLite.delayedCall( 0, animateCopy, [copy] ));
			timeline.append( TweenLite.delayedCall( .7, cta.gotoAndPlay, [0] ));
		}
		
		private function animateCopy(copy:MovieClip):void
		{
			copy.alpha = 1;
			trace(copy.numChildren)
			for (var i:int=0; i < copy.numChildren; i++)
			{
				copy.getChildAt(i).alpha = 1;
				TweenLite.from(copy.getChildAt(i), .5, { delay: i * .1, alpha:0, scaleX:.5, scaleY:.5, ease: Back.easeOut });
			}
			clickArea.addEventListener( MouseEvent.MOUSE_OVER, ctaOver);
		}
		
		private function ctaOver(event:MouseEvent = null):void
		{
			//Loops thru all the layers in faces_mc an stores the original x + y values in an array
			//that array is used to reference those original values
			for(var i=0; i<faces_mc.numChildren; i++)
			{
				initialX.push(faces_mc.getChildAt(i).x)
				initialY.push(faces_mc.getChildAt(i).y)
			}
			
			this.addEventListener(Event.ENTER_FRAME, hoverEffect);
			clickArea.addEventListener( MouseEvent.MOUSE_OUT, ctaOut);
			clickArea.removeEventListener( MouseEvent.MOUSE_OVER, ctaOver);
			TweenLite.to(cta, .5, {tint:0x131d26});
			
		}
		
		private function ctaOut(event:MouseEvent = null):void
		{
			this.removeEventListener(Event.ENTER_FRAME, hoverEffect);
			clickArea.removeEventListener( MouseEvent.MOUSE_OUT, ctaOut);
			clickArea.addEventListener( MouseEvent.MOUSE_OVER, ctaOver);
			TweenLite.to(cta, .5, {tint:0x4e6375});
			
			 for(var i=0; i<faces_mc.numChildren; i++)
			{
				TweenLite.to(faces_mc.getChildAt(i), .5, { x:initialX[i], y:initialY[i] , ease:Quad.easeOut  });

			}
		}
		
		
		private function hoverEffect(event:Event = null):void
		{			
			faces_mc.layer1_mc.x = 40*(mouseX/stageWidth)-20 - (initialX[0] * -1);
			faces_mc.layer1_mc.y = 20*(mouseY/stageHeight)-10 - (initialY[0] * -1);
			
			faces_mc.layer2_mc.x = 35*(mouseX/stageWidth)-17.5 - (initialX[1] * -1);
			faces_mc.layer2_mc.y = 20*(mouseY/stageHeight)-10 - (initialY[1] * -1);
			
			faces_mc.layer3_mc.x = 30*(mouseX/stageWidth)-15 - (initialX[2] * -1);
			faces_mc.layer3_mc.y = 20*(mouseY/stageHeight)-10 - (initialY[2] * -1);
			
			faces_mc.layer4_mc.x = 25*(mouseX/stageWidth)-12.5 - (initialX[3] * -1);
			faces_mc.layer4_mc.y = 20*(mouseY/stageHeight)-10 - (initialY[3] * -1);
			
			faces_mc.layer5_mc.x = 17*(mouseX/stageWidth)-8.5 - (initialX[4] * -1);
			faces_mc.layer5_mc.y = 13*(mouseY/stageHeight)-7.5 - (initialY[4] * -1);
			
			faces_mc.layer6_mc.x =  10*(mouseX/stageWidth)-5 - (initialX[5] * -1);
			faces_mc.layer6_mc.y =  10*(mouseY/stageHeight)-5 - (initialY[5] * -1);
		}
	}
}